#include <machine/asmacros.h>

#define	VENTER	push %rbp; mov %rsp, %rbp
#define	VLEAVE	pop %rbp

/*
 * void frame_push_pop(u_long iterations)
 * %rdi: iterations
 */
ENTRY(frame_push_pop)
	VENTER
1:
	push %rbx
	push %r12
	push %r13
	push %r14
	push %r15

	pop %r15
	pop %r14
	pop %r13
	pop %r12
	pop %rbx

	subq $1, %rdi
	cmpq $0, %rdi
	jne 1b

	VLEAVE
	ret
END(frame_push_pop)

/*
 * void frame_move_move(u_long iterations)
 * %rdi: iterations
 */
ENTRY(frame_mov_mov)
	VENTER
1:
	subq $40, %rsp
	mov %rbx, 0(%rsp)
	mov %r12, 8(%rsp)
	mov %r13, 16(%rsp)
	mov %r14, 24(%rsp)
	mov %r15, 32(%rsp)

	mov 32(%rsp), %r15
	mov 24(%rsp), %r14
	mov 16(%rsp), %r13
	mov 8(%rsp), %r12
	mov 0(%rsp), %rbx
	addq $40, %rsp

	subq $1, %rdi
	cmpq $0, %rdi
	jne 1b

	VLEAVE
	ret
END(frame_mov_mov)
